VERSION 5.00
Object = "{C1A8AF28-1257-101B-8FB0-0020AF039CA3}#1.1#0"; "MCI32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdTrack 
      Caption         =   "Command1"
      Height          =   495
      Index           =   0
      Left            =   1740
      TabIndex        =   1
      Top             =   1380
      Width           =   1215
   End
   Begin MCI.MMControl mciMain 
      Height          =   495
      Left            =   600
      TabIndex        =   0
      Top             =   1380
      Width           =   3555
      _ExtentX        =   6271
      _ExtentY        =   873
      _Version        =   393216
      DeviceType      =   ""
      FileName        =   ""
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'For this example create the following controls: _
    an MM Control named mciMain _
    a CommandButton named cmdTrack _
        with the Index property set to 0

Dim WithEvents txtTrack As TextBox
Attribute txtTrack.VB_VarHelpID = -1
Dim WithEvents txtTime As TextBox
Attribute txtTime.VB_VarHelpID = -1

Private Sub Form_Load()
    'Set up Form and Controls
    Me.Caption = "No Disk"
    
    'Create TextBox Controls
    Set txtTrack = Me.Controls.Add("vb.textbox", "txtTrack", Me)
    txtTrack.Text = ""
    txtTrack.Visible = True
    txtTrack.Locked = True
    
    Set txtTime = Me.Controls.Add("vb.textbox", "txtTime", Me)
    txtTime.Text = ""
    txtTime.Visible = True
    txtTime.Locked = True
    
    Me.cmdTrack(0).Caption = ""
    Me.cmdTrack(0).Visible = False
    
    'Set MM Control Properties
    Me.mciMain.DeviceType = "CDAudio"
    Me.mciMain.Wait = True
    Me.mciMain.Command = "Open"
    Me.mciMain.Wait = False
    Me.mciMain.AutoEnable = True
    Me.mciMain.BackVisible = False
    Me.mciMain.StepVisible = False
    Me.mciMain.RecordVisible = False
    Me.mciMain.TimeFormat = mciFormatTmsf
    Me.mciMain.UpdateInterval = 1000
    Me.mciMain.Shareable = False
End Sub

Private Sub Form_Resize()
    'Not much resizing going on in this form
    txtTrack.Move 120, 120, 1095, 315
    txtTime.Move 1335, 120, 1095, 315
    Me.mciMain.Move 120, 555
    
    RedrawTracks
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'Some clean-up here
    Me.mciMain.Command = "Close"
End Sub

Private Sub cmdTrack_Click(Index As Integer)
    'I've found that often the Seek doesn't work the _
    first time when the CD is already playing
    Do While Me.mciMain.Position <> Index + 1
        Me.mciMain.To = Index + 1
        Me.mciMain.Command = "Seek"
        DoEvents
    Loop
End Sub

Private Sub mciMain_StatusUpdate()
    Static lPos As Long
    'If the old position was 0 and the new position _
        isn't, a CD has been loaded into the drive
    If lPos = 0 And Me.mciMain.Position > 0 Then
        GetTracks
        RedrawTracks
        'If the new position is 0 and the old _
            position wasn't, the CD has been ejected
    ElseIf Me.mciMain.Position = 0 And lPos > 0 Then
        ClearTracks
        RedrawTracks
    End If
    
    lPos = Me.mciMain.Position
    
    GetCurrentTrack
End Sub

Private Sub GetCurrentTrack()
    Dim iTrack As Integer
    Dim iMinute As Integer
    Dim iSecond As Integer
    Dim iFrame As Integer
    Dim lTime As Long
    
    If Me.mciMain.Position = 1 Then
        iMinute = Me.mciMain.Length And 255
        iSecond = (Me.mciMain.Length And 65280) \ 256
        Me.Caption = "CD Info: " & Format$(Me.mciMain.Tracks, "##0") & " Tracks - " & Format$(iMinute, "##0") & ":" & Format$(iSecond, "00")
    End If
    
    If Me.mciMain.Position < 256 Then
        'Since the Position is 255 or less, we know _
            there is only a track and no minutes or _
            seconds. That means we're at the very beginning _
            of the track. Therefore we'll display the time _
            for the whole track in txtTime
        iTrack = Me.mciMain.Position
        Me.mciMain.Track = iTrack
        lTime = Me.mciMain.TrackLength
        iMinute = lTime And 255
        iSecond = (lTime And 65280) \ 256
    Else
        'Were not at the beginning of a track so we'll _
            show the current positon in txtTime
        lTime = Me.mciMain.Position
        iTrack = lTime And 255
        iMinute = (lTime And 65280) \ 256
        iSecond = (lTime And 16711680) \ 65536
    End If
    
    txtTrack = Format$(iTrack, "#00")
    txtTime = Format$(iMinute, "##0") & ":" & _
    Format$(iSecond, "00")
End Sub
Private Sub GetTracks()
    Dim iCtr As Integer
    
    'Here we want to create one button for each track _
        on the CD
    For iCtr = 0 To Me.mciMain.Tracks - 1
        If iCtr > 0 Then
            Load Me.cmdTrack(iCtr)
        End If
        Me.cmdTrack(iCtr).Caption = iCtr + 1
        Me.cmdTrack(iCtr).Visible = True
    Next iCtr
End Sub

Private Sub ClearTracks()
    Dim iCtr As Integer
    Dim cmdVar As CommandButton
    
    'Since there's no CD in the drive, we'll delete _
        all the track buttons
    For Each cmdVar In Me.cmdTrack()
        If cmdVar.Index > 0 Then
            Unload Me.cmdTrack(cmdVar.Index)
        Else
            cmdVar.Visible = False
        End If
    Next cmdVar
    Me.Caption = "No Disk"
End Sub

Private Sub RedrawTracks()
    Dim cmdVar As CommandButton
    
    Const TRACKS_ACROSS = 6
    
    'Well show the tracks in rows of buttons. The _
        number of buttons across is set by the _
        TRACKS_ACROSS constant
    For Each cmdVar In Me.cmdTrack()
        cmdVar.Move 120 + ((Me.mciMain.Width \ TRACKS_ACROSS) * (cmdVar.Index Mod TRACKS_ACROSS)), Me.mciMain.Top + Me.mciMain.Height + 120 + (375 * (cmdVar.Index \ TRACKS_ACROSS)), Me.mciMain.Width \ TRACKS_ACROSS, 375
    Next cmdVar
End Sub

Private Sub mciMain_StopCompleted(Errorcode As Long)
    'When the user hits the Stop button we want to _
        make sure the position is reset
    Me.mciMain.To = 1
    Me.mciMain.Command = "Seek"
End Sub
